Stat the open file instead of the filesystem name, don't crash if the user
prompt isn't already set, and fix an off-by-one error when building the final
version of the prompt string.
--- Linux-PAM-0.75/modules/pam_issue/pam_issue.c
+++ Linux-PAM-0.75/modules/pam_issue/pam_issue.c
@@ -83,7 +83,7 @@
     if ((fd = fopen(issue_file, "r")) != NULL) {
 	int tot_size = 0;
 
-	if (stat(issue_file, &st) < 0)
+	if (fstat(fileno(fd), &st) < 0)
 	    return PAM_IGNORE;
 
 	retval = pam_get_item(pamh, PAM_USER_PROMPT, (const void **) &cur_prompt);
@@ -105,14 +105,14 @@
 
 	fclose(fd);
 
-	tot_size = strlen(prompt_tmp) + strlen(cur_prompt) + 1;
+	tot_size = strlen(prompt_tmp) + strlen(cur_prompt ?: "") + 1;
 
        /*
 	* alloc some extra space for the original prompt
 	* and postpend it to the buffer
 	*/
-	prompt_tmp = realloc(prompt_tmp, tot_size);
-	strcpy(prompt_tmp+strlen(prompt_tmp), cur_prompt);
+	prompt_tmp = realloc(prompt_tmp, tot_size + 1);
+	strcpy(prompt_tmp+strlen(prompt_tmp), cur_prompt ?: "");
 
 	prompt_tmp[tot_size] = '\0';
 
